{
Programm, mis ksitleb objektitehnika abil graafikaid.
J. Pant, XI 1997.
}

program objektgr;

type
 graafika13h=object                       {algobjekt}
  maxx,
  maxy,
  maxvarv:word;
  varv:byte;
  constructor init;
  procedure initgr(mood:word);VIRTUAL;
  procedure pixel(x,y:integer;c:byte);VIRTUAL;
  procedure ellips(x,y:integer;alg,l6pp,a,b:word);
  procedure ring(x,y:integer;r:word);
  procedure ristkylik(x1,y1,x2,y2:integer);
  procedure l6ik(x1,y1,x2,y2:integer);
  end;

 pseudograafika=object(graafika13h)       {primine}
  constructor init;
  procedure initgr(mood:word);VIRTUAL;    {polmorfism}
  procedure pixel(x,y:integer;c:byte);VIRTUAL;
  procedure plaz_puhtax(varvid:byte);
  end;


constructor graafika13h.init;
 begin   {konstantide ja algse joonistamisvrvuse sisestus}
  maxx:=319;
  maxy:=199;
  maxvarv:=255;
  varv:=15;
 end;


procedure graafika13h.initgr(mood:word);assembler;{parameeter  mood            }
 asm                                              {         3  tekstimood      }
  mov ax,mood                                     {        19  graafikamood 13h}
  int 10h
 end;


procedure graafika13h.pixel(x,y:integer;c:byte);  {c->color=(punkti) vrv}
 begin
   if (x>=0) and (y>=0) and (x<=maxx) and (y<=maxy) then
    mem[$a000:y*320+x]:=c;
 end;


procedure graafika13h.ellips(x,y:integer;alg,l6pp,a,b:word);
 var beeta,t:real;
     abi:word;
 begin
  if alg>l6pp then
   begin
    abi:=alg;
    alg:=l6pp;
    l6pp:=abi;
   end;
  t:=2*pi*alg/360;
  beeta:=2*pi*l6pp/360;
  repeat
   pixel(x+round(a*cos(t)),y+round(b*sin(t)),varv);
   t:=t+0.006;
  until t>beeta;
 end;


procedure graafika13h.ring(x,y:integer;r:word);
 begin
  ellips(x,y,0,360,r,r);
 end;


procedure graafika13h.ristkylik(x1,y1,x2,y2:integer);
 var abi:integer;
 begin
  if x1>x2 then
   begin
    abi:=x1;
    x1:=x2;
    x2:=abi;
   end;
  if y1>y2 then
   begin
    abi:=y1;
    y1:=y2;
    y2:=abi;
   end;
  for abi:=x1 to x2 do pixel (abi,y1,varv);    {lemine}
  for abi:=x1 to x2 do pixel (abi,y2,varv);    {alumine}
  for abi:=y1+1 to y2-1 do pixel (x1,abi,varv);{vasak}
  for abi:=y1+1 to y2-1 do pixel (x2,abi,varv);{parem}
 end;


procedure graafika13h.l6ik(x1,y1,x2,y2:integer);
 var dx,dy,abi:integer;
     k:real;
 begin
  k:=0;
  if x1>x2 then
   begin
    abi:=x1; x1:=x2; x2:=abi;
    abi:=y1; y1:=y2; y2:=abi;
   end;
  dx:=x2-x1;
  dy:=y2-y1;
  if dx<>0 then k:=dy/dx;
  if (dx=0) or (k>1) or (k<-1) then
   begin
    if y1>y2 then
     begin
      abi:=x1; x1:=x2; x2:=abi;
      abi:=y1; y1:=y2; y2:=abi;
     end;
    dx:=x2-x1;
    dy:=y2-y1;
    k:=dx/dy;
    for abi:= y1 to y2 do pixel(round(k*(abi-y1))+x1,abi,varv);
   end
   else for abi:= x1 to x2 do pixel(abi,round(k*(abi-x1))+y1,varv);
 end;



constructor pseudograafika.init;
 begin    {konstantide ja algse joonistamisvrvuse sisestus}
  maxx:=79;
  maxy:=49;
  maxvarv:=7;
  varv:=7;
 end;


procedure pseudograafika.initgr(mood:word);
 var i:integer;
     abi:byte;
 begin
  i:=0;
  abi:=mood mod 256;
  repeat
   mem[$b800:i]:=220;
   mem[$b800:i+1]:=abi;
   inc(i,2);
  until i>=4000;
 end;


procedure pseudograafika.pixel(x,y:integer;c:byte);
 var varvid:byte;
     abi:word;
 begin
   if (x>=0) and (y>=0) and (x<=maxx) and (y<=maxy) then
    begin
     abi:=160*(y div 2)+2*x+1;
     varvid:=mem[$b800:abi];
     if odd(y) then  {alumine}
       mem[$b800:abi]:=((varvid shr 4) shl 4)+c
      else mem[$b800:abi]:= (c shl 4)+varvid mod 16;
    end;
 end;

procedure pseudograafika.plaz_puhtax(varvid:byte);
 var i:integer;
 begin
  i:=0;
  repeat
   mem[$b800:i]:=32;
   mem[$b800:i+1]:=varvid;
   inc(i,2);
  until i>=4000;
 end;

var g:graafika13h;
    p:pseudograafika;
    abi:byte;
begin
 g.init;
 g.initgr(19);          {graafika 13h kivitamine}
 for abi:=0 to g.maxvarv do
  begin                 {"vikerkaare" joonistamine}
    g.varv:=abi;
    g.l6ik(abi,0,abi,g.maxy);
  end;
 g.varv:=15;            {lejnud graafikademo}
 g.ellips(g.maxx div 2,g.maxy div 2,0,360,g.maxx div 2,g.maxy div 2);
 g.ring(g.maxx div 2,g.maxy div 2,g.maxy div 2);
 g.ristkylik(0,0,g.maxx,g.maxy);
 g.l6ik(0,0,g.maxx,g.maxy);
 readln;                {vajuta ENTERit!}
 g.initgr(3);           {tekstimoodi tagasi}
 p.init;
 p.initgr(0);           {pseudograafika kivitamine, parameeter mrab tausta}
 p.pixel(0,0,15);
 for abi:=0 to p.maxvarv do
  begin                 {"vikerkaare" joonistamine}
    p.varv:=abi;
    p.l6ik(abi,0,abi,p.maxy);
  end;
 p.varv:=7;            {lejnud graafikademo}
 p.ellips(p.maxx div 2,p.maxy div 2,0,360,p.maxx div 2,p.maxy div 2);
 p.ring(p.maxx div 2,p.maxy div 2,p.maxy div 2);
 p.ristkylik(0,0,p.maxx,p.maxy);
 p.l6ik(0,0,p.maxx,p.maxy);
 readln;                {lpetamiseks vajuta ENTERit!}
 p.plaz_puhtax(15);     {tekstiekraani kordategemine}
end.